''*****************************
''*  16Colour Bitmap          *
''*  (C) 2009 Jim Bagley      *
''*****************************

CON

'{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000
'}

{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  modepins = %001_0101
'}

{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000
'}

PAL=%0001
NTSC=%0000
INTERLACED=%0010

x_tiles = 8 '*16=256
y_tiles = 12 '*16=192
mode = 0
my_hx = 22+((mode&1)<<1)

x_pixels = x_tiles*16
y_pixels = y_tiles*16
  
OBJ
  tv    : "JB_TV_AMS_01"

VAR
  long  frame

PUB Main | i,c,x,y

  tv.start(@tvparams)
  frame:=0

  repeat 5*60
    VSync

  c:=0
  repeat i from 0 to 63
    repeat x from i to 127-i
      plot(x,i,c)
      c++
    repeat y from i to 191-i
      plot(127-i,y,c)
      c++
    repeat x from i to 127-i
      plot(127-x,191-i,c)
      c++
    repeat y from i to 191-i
      plot(i,191-y,c)
      c++
    VSync

  c:=0
  repeat i from 63 to 1         ' back down to 1, to leave a border of colours onscreen
    repeat x from i to 127-i
      plot(x,i,c)
    repeat y from i to 191-i
      plot(127-i,y,c)
    repeat x from i to 127-i
      plot(127-x,191-i,c)
    repeat y from i to 191-i
      plot(i,191-y,c)
    VSync

  repeat
'    VSync
    repeat 500
    bordercolour:=$2d-bordercolour

PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$f0)+c
  else
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$0f)+(c<<4)
    
PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1
    
DAT

tvparams      long    0               'status
              long    1               'enable
              long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
              long    mode            'mode
              long    x_tiles         'hc
              long    y_tiles         'vc
              long    my_hx           'hx
VSyncFlag     long    0
nextline      long    0                        
disp_ptr      long    @data+$10
bordercolour  long    $02
              long    @palette+$10

palette       byte    $02,$07,$28,$8d,$ba,$1a,$db,$3d,$8f,$5f,$3f,$5b,$d8,$04,$02,$02

data          file    "mrheli.bit"